export const authorizedByPermission = (auth, authInput) => typeof auth === 'boolean' ||
    auth.some(x => (authInput.permissions || []).some(y => x === y));
export const getUserIdFields = (fields) => Object.entries(fields).filter(x => x[1]).map(x => x[0]);
export const filterToAccess = (input, auth, authInput, fields) => authorizedByPermission(auth, authInput) ? input : input.filter((x) => getUserIdFields(fields).some(y => x[y] === authInput.sub));
export const keyId = (index, id) => `${index}:records:${id}`;
export const forbidden = (data, errors = ['forbidden']) => ({
    errorType: 'forbidden',
    data,
    status: 403,
    errors
});
export const notFound = (data, errors = ['not found']) => ({
    errorType: 'notFound',
    data,
    status: 404,
    errors
});
//# sourceMappingURL=backendAbstract.js.map