"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.notFound = exports.forbidden = exports.keyId = exports.filterToAccess = exports.getUserIdFields = exports.authorizedByPermission = void 0;
exports.authorizedByPermission = (auth, authInput) => typeof auth === 'boolean' ||
    auth.some(x => (authInput.permissions || []).some(y => x === y));
exports.getUserIdFields = (fields) => Object.entries(fields).filter(x => x[1]).map(x => x[0]);
exports.filterToAccess = (input, auth, authInput, fields) => exports.authorizedByPermission(auth, authInput) ? input : input.filter((x) => exports.getUserIdFields(fields).some(y => x[y] === authInput.sub));
exports.keyId = (index, id) => `${index}:records:${id}`;
exports.forbidden = (data, errors = ['forbidden']) => ({
    errorType: 'forbidden',
    data,
    status: 403,
    errors
});
exports.notFound = (data, errors = ['not found']) => ({
    errorType: 'notFound',
    data,
    status: 404,
    errors
});
//# sourceMappingURL=backendAbstract.js.map