"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.processHandle = exports.errorStructure = void 0;
const contractValidation_js_1 = require("./contractValidation.js");
const microtil_1 = require("microtil");
function isPrimitive(test) {
    return (test !== Object(test));
}
;
exports.errorStructure = (status, errorType, errors, data) => ({ status, errorType, data, errors: [errors] });
exports.processHandle = (contract) => (body, id, user) => __awaiter(void 0, void 0, void 0, function* () {
    const { authentication, manageFields } = contract;
    if (authentication) {
        if (!(user === null || user === void 0 ? void 0 : user.sub)) {
            return exports.errorStructure(401, 'unauthorized', 'Only logged in users can do this', { id });
        }
        if (Array.isArray(authentication)) {
            const perm = user.permissions || [];
            const hasPerm = perm.some(y => authentication.some(z => z === y));
            const canUserAccess = manageFields.createdBy;
            if (!hasPerm && !canUserAccess) {
                return exports.errorStructure(403, 'forbidden', "You don't have permission to do this", { id });
            }
        }
    }
    try {
        const result = yield contractValidation_js_1.wrapHandleWithValidation(contract)(body, Object.assign({}, user), id);
        return Object.assign(Object.assign({}, result), { status: result.status || (contract.type === 'POST' ? 201 : 200) });
    }
    catch (e) {
        const normalizeErrorCode = (input) => input >= 400 && input < 600 ? input : 500;
        const getIfNumber = (input) => typeof input === 'number' && normalizeErrorCode(input);
        const data = (isPrimitive(e) || !e) ? e : microtil_1.map(e, y => y);
        const code = getIfNumber(e === null || e === void 0 ? void 0 : e.status) || getIfNumber(e === null || e === void 0 ? void 0 : e.statusCode) || getIfNumber(e === null || e === void 0 ? void 0 : e.code) || 500;
        return exports.errorStructure(code, (e === null || e === void 0 ? void 0 : e.name) || 'exception', (e === null || e === void 0 ? void 0 : e.message) || (e === null || e === void 0 ? void 0 : e.toString()) || 'unknown', data);
    }
});
//# sourceMappingURL=process.js.map